#ifndef __init_cm3board_H
#define __init_cm3board_H
#define cortex_m3 1
#define u8 uint8_t
#define u16 uint16_t
#define u32 uint32_t


#define EINT0		0x00000001
#define EINT1		0x00000002
#define EINT2		0x00000004
#define EINT3		0x00000008
#define EINT0_EDGE	0x00000001
#define EINT1_EDGE	0x00000002
#define EINT2_EDGE	0x00000004
#define EINT3_EDGE	0x00000008


#define 	led1_off		LPC_GPIO3->FIOCLR|=(1<<25)
#define 	led1_on 		LPC_GPIO3->FIOSET|=(1<<25)
#define 	led1_tog 	{if(LPC_GPIO3->FIOPIN && (1<<25))led1_off;else led1_on;}
#define 	led2_off		LPC_GPIO3->FIOCLR|=(1<<26)
#define 	led2_on 		LPC_GPIO3->FIOSET|=(1<<26)
#define 	led2_tog 	{if(LPC_GPIO3->FIOPIN && (1<<26))led2_off;else led2_on;}


#define mosi_h		  LPC_GPIO0->FIOSET|=(1<<18)
#define mosi_l		  LPC_GPIO0->FIOCLR|=(1<<18)
#define sck_h		  LPC_GPIO0->FIOSET|=(1<<15)
#define sck_l		  LPC_GPIO0->FIOCLR|=(1<<15)


//#include <kk/ssp.h>
#include "rtc.h"
#include "glcd/glcd.h"
#include "glcd/kklcdxx.h"

//=========================================
volatile uint32_t zlrtc=0;
uint32_t F_DELAY;
//=========================================
void RTC_IRQHandler(void){
			//secval = RTC_GetTime (LPC_RTC, RTC_TIMETYPE_SECOND);
	LPC_RTC->ILR |= ILR_RTCCIF;		/* clear interrupt flag */
//	led2_tog;
	zlrtc++;
		/* Clear pending interrupt */
		}
void EINT0_IRQHandler (void)
{
  LPC_SC->EXTINT = EINT0;		/* clear interrupt */
led2_tog;
}

void lcd_rtc(void){
	RTCGetTime();
	lcd_goto(1,1);
	lcd_int2(LPC_RTC->HOUR);
	lcd_write(":");
	lcd_int2(LPC_RTC->MIN);
	lcd_write(":");
	lcd_int2(LPC_RTC->SEC);
}

//+++++++++++++++++++++++++++++++++++++++++


void swspi_send(uint8_t databyte){
	uint8_t i;
	for(i=8;i>0;i--){
	  mosi_l;
	  if(databyte & 128)mosi_h;
	  databyte <<=1;
	  sck_h;
	  sck_l;
	}
}



void cpuspeed(void){
	uint32_t i=0;
	zlrtc=0;
	led2_off;
	while(zlrtc<1);
	led2_on;
	while(zlrtc<3)i++;
	led2_off;
	F_DELAY=i/1836;
	lwi(2,1,"F_DELAY_1ms:");
	lgi(3,1,F_DELAY);
	lcd_write("xx");

	u32 kk_clksrcsel,
	kk_pll0statlow=((LPC_SC->PLL0STAT >> 16) & 0xFF)+1,
	kk_pll0stathighi=LPC_SC->PLL0STAT&0x7FFF+1,
	kk_ndivider=((LPC_SC->CCLKCFG & 0xFF)+ 1);

		switch (LPC_SC->CLKSRCSEL & 0x03){
		case 3:	kk_clksrcsel=4000000;break;
		case 1:	kk_clksrcsel=12000000;break;
		case 2:	kk_clksrcsel=32000;break;
		}
#ifdef SystemFrequency
#define SystemCoreClock SystemFrequency
#endif
		lgi(4,1,SystemCoreClock);
		lgi(5,1,kk_clksrcsel);
		lgi(6,1,kk_pll0statlow);
		lgi(7,1,kk_pll0stathighi);
		lgi(8,1,kk_ndivider);
}



_delay_ms(uint32_t ms){
	//genau auf 100sec
	//bei 72Mhz F_CPU=6536
uint32_t i,j=F_DELAY*ms;
	for(i=0;i<j;i++);
}

_delay_us(uint32_t us){//genau auf 100sec
uint32_t i,j=F_DELAY*us/1000;
	for(i=0;i<j;i++);
}
#define wait _delay_ms(1000)










void init_all(void){
//gpio out
LPC_GPIO3->FIODIR |=(1<<25);		//led1 P2.xx defined as Outputs
 LPC_GPIO3->FIODIR |=(1<<26);		//led2 P2.xx defined as Outputs
 LPC_GPIO0->FIODIR |=(1<<16);		//spi cs
//rtc
 RTCInit();
 RTCStart();
 LPC_RTC->CIIR|=IMSEC;
 NVIC_EnableIRQ(RTC_IRQn);
 LPC_RTC->ILR |= ILR_RTCCIF;		/* clear interrupt flag */
 //lcd
  LCD_Initializtion();
 LCD_Clear(Red);
 selectfont(2);
 lwi(16,14,"LPC1768-Mini-DK");
 lwi(17,14,"Development Board");
  //	  init_lcd();

//gpio input
LPC_GPIOINT->IO2IntEnF |= (1 << 10);
LPC_GPIOINT->IO2IntEnF |= (1 << 11);
LPC_GPIOINT->IO2IntEnF |= (1 << 12);


NVIC_SetPriority(EINT1_IRQn,1);
NVIC_EnableIRQ(EINT0_IRQn);
NVIC_EnableIRQ(EINT1_IRQn);
NVIC_EnableIRQ(EINT2_IRQn);
/* is Input */

LPC_PINCON->PINSEL4 = 0x00100000;	// set P2.10 as EINT0 and
LPC_GPIOINT->IO2IntEnF = 0x200;	    // Port2.10 is falling edge. */
LPC_SC->EXTMODE = EINT0_EDGE;		/* INT0 edge trigger */
LPC_SC->EXTPOLAR = 0;				/* INT0 is falling edge by default */

NVIC_EnableIRQ(EINT0_IRQn);
cpuspeed();

 
 
}


#endif